org.osgi.service.remoteserviceadmin

## Class EndpointPermission

- java.lang.Object
- - java.security.Permission
  - - org.osgi.service.remoteserviceadmin.EndpointPermission

All Implemented Interfaces:
  Serializable, Guard

    public final class EndpointPermission
    extends Permission

A bundle's authority to export, import or read an Endpoint.

- The `export` action allows a bundle to export a service as an Endpoint.
- The `import` action allows a bundle to import a service from an Endpoint.
- The `read` action allows a bundle to read references to an Endpoint.

Permission to read an Endpoint is required in order to detect events regarding an Endpoint. Untrusted bundles should not be able to detect the presence of certain Endpoints unless they have the appropriate `EndpointPermission` to read the specific service.

See Also:
  Serialized Form

### Field Summary

Fields
`static String` `EXPORT` The action string `export`.
`static String` `IMPORT` The action string `import`.
`static String` `READ` The action string `read`.

### Constructor Summary

Constructors
Constructor and Description
`EndpointPermission(EndpointDescription endpoint, String localFrameworkUUID, String actions)` Creates a new requested `EndpointPermission` object to be used by code that must perform `checkPermission`.
`EndpointPermission(String filterString, String actions)` Create a new EndpointPermission with the specified filter.

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `equals(Object obj)` Determines the equality of two EndpointPermission objects.
`String` `getActions()` Returns the canonical string representation of the actions.
`int` `hashCode()` Returns the hash code value for this object.
`boolean` `implies(Permission p)` Determines if a `EndpointPermission` object "implies" the specified permission.
`PermissionCollection` `newPermissionCollection()` Returns a new `PermissionCollection` object for storing `EndpointPermission` objects.

### Methods inherited from class java.security.Permission

`checkGuard, getName, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### READ

    public static final String READ

The action string `read`.

See Also:
  Constant Field Values

#### IMPORT

    public static final String IMPORT

The action string `import`. The `import` action implies the `read` action.

See Also:
  Constant Field Values

#### EXPORT

    public static final String EXPORT

The action string `export`. The `export` action implies the `read` action.

See Also:
  Constant Field Values

### Constructor Detail

#### EndpointPermission

    public EndpointPermission(String filterString,
                              String actions)

Create a new EndpointPermission with the specified filter.

The filter will be evaluated against the endpoint properties of a requested EndpointPermission.

There are three possible actions: `read`, `import` and `export`. The `read` action allows the owner of this permission to see the presence of distributed services. The `import` action allows the owner of this permission to import an endpoint. The `export` action allows the owner of this permission to export a service.

Parameters:
  `filterString` - The filter string or "*" to match all endpoints.
  `actions` - The actions `read`, `import`, or `export`.
Throws:
  `IllegalArgumentException` - If the filter has an invalid syntax or the actions are not valid.

#### EndpointPermission

    public EndpointPermission(EndpointDescription endpoint,
                              String localFrameworkUUID,
                              String actions)

Creates a new requested `EndpointPermission` object to be used by code that must perform `checkPermission`. `EndpointPermission` objects created with this constructor cannot be added to an `EndpointPermission` permission collection.

Parameters:
  `endpoint` - The requested endpoint.
  `localFrameworkUUID` - The UUID of the local framework. This is used to support matching the `endpoint.framework.uuid` endpoint property to the `<<LOCAL>>` value in the filter expression.
  `actions` - The actions `read`, `import`, or `export`.
Throws:
  `IllegalArgumentException` - If the endpoint is `null` or the actions are not valid.

### Method Detail

#### implies

    public boolean implies(Permission p)

Determines if a `EndpointPermission` object "implies" the specified permission.

Specified by:
  `implies` in class `Permission`
Parameters:
  `p` - The target permission to check.
Returns:
  `true` if the specified permission is implied by this object; `false` otherwise.

#### getActions

    public String getActions()

Returns the canonical string representation of the actions. Always returns present actions in the following canonical order: `read`, `import`, `export`.

Specified by:
  `getActions` in class `Permission`
Returns:
  The canonical string representation of the actions.

#### newPermissionCollection

    public PermissionCollection newPermissionCollection()

Returns a new `PermissionCollection` object for storing `EndpointPermission` objects.

Overrides:
  `newPermissionCollection` in class `Permission`
Returns:
  A new `PermissionCollection` object suitable for storing `EndpointPermission` objects.

#### equals

    public boolean equals(Object obj)

Determines the equality of two EndpointPermission objects. Checks that specified object has the same name, actions and endpoint as this `EndpointPermission`.

Specified by:
  `equals` in class `Permission`
Parameters:
  `obj` - The object to test for equality.
Returns:
  true If obj is a `EndpointPermission`, and has the same name, actions and endpoint as this `EndpointPermission` object; `false` otherwise.

#### hashCode

    public int hashCode()

Returns the hash code value for this object.

Specified by:
  `hashCode` in class `Permission`
Returns:
  Hash code value for this object.